# coding: utf-8

"""
    Buy Offer API

    <span class=\"tablenote\"><b>Note:</b> This is a <a href=\"https://developer.ebay.com/api-docs/static/versioning.html#limited\" target=\"_blank\"> <img src=\"/cms/img/docs/partners-api.svg\" class=\"legend-icon partners-icon\" title=\"Limited Release\"  alt=\"Limited Release\" />(Limited Release)</a> API available only to select developers approved by business units.</span><br /><br />The Buy Offer API enables Partners to place proxy bids for a buyer and retrieve the auctions where the buyer is bidding.  By placing a proxy bid, the buyer is agreeing to purchase the item if they win the auction. </p>   # noqa: E501

    OpenAPI spec version: v1_beta.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UserConsent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'adult_only_item': 'bool'
    }

    attribute_map = {
        'adult_only_item': 'adultOnlyItem'
    }

    def __init__(self, adult_only_item=None):  # noqa: E501
        """UserConsent - a model defined in Swagger"""  # noqa: E501
        self._adult_only_item = None
        self.discriminator = None
        if adult_only_item is not None:
            self.adult_only_item = adult_only_item

    @property
    def adult_only_item(self):
        """Gets the adult_only_item of this UserConsent.  # noqa: E501

        The type that defines the fields for buyer consent to bid on adult-only items. This field must be included in the placeProxyBid request and set to true if the buyer is bidding on an adult-only item. For more information about adult-only items on eBay, see Adult-Only items on eBay.  # noqa: E501

        :return: The adult_only_item of this UserConsent.  # noqa: E501
        :rtype: bool
        """
        return self._adult_only_item

    @adult_only_item.setter
    def adult_only_item(self, adult_only_item):
        """Sets the adult_only_item of this UserConsent.

        The type that defines the fields for buyer consent to bid on adult-only items. This field must be included in the placeProxyBid request and set to true if the buyer is bidding on an adult-only item. For more information about adult-only items on eBay, see Adult-Only items on eBay.  # noqa: E501

        :param adult_only_item: The adult_only_item of this UserConsent.  # noqa: E501
        :type: bool
        """

        self._adult_only_item = adult_only_item

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserConsent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserConsent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
